#!/usr/bin/python3
import subprocess
import sys, os
import cgi
import cgitb, jinja2, urllib.request
import re
from pathlib import Path

cgitb.enable()
print("Content-Type: text/html\n\n")
HTML = '''<!DOCTYPE html>
<html><head>
<meta charset="UTF-8">
<title>Modern Menu</title>
<style>
  #menu {
    background-color: #bdf5fc;
    width: 200px; /* Adjust width as needed */
    padding: 20px;
    box-sizing: border-box;
  }

  #menu b {
    font-size: 24px; /* Larger font size for the menu title */
    color: #333; /* Darker color for better readability */
    margin-bottom: 20px; /* Space below the menu title */
    display: inline-block; /* To enable margin to work */
  }

  #menu a {
    display: block; /* Make each link take its own line */
    color: #007bff; /* A more vibrant link color */
    text-decoration: none; /* Remove underline */
    margin: 10px 0; /* Space between links */
    padding: 8px; /* Padding inside links for larger click area */
    border-radius: 5px; /* Rounded corners for links */
    transition: background-color 0.3s, color 0.3s; /* Smooth transition for hover effects */
  }

  #menu a:hover {
    background-color: #007bff; /* Background color on hover */
    color: #ffffff; /* Text color on hover */
  }

  /* Additional style to remove link spacing and align to the left */
  body {
    margin: 0;
    font-family: Arial, sans-serif; /* Modern font */
  }
</style>
<title></title>
</head>

<body>
  <div id="header" style="background-color:#00c062;text-align:center">
    <h1 style="margin-bottom:0;">Gruppe 7</h1>
  </div>

  <div id="menu" style="background-color:#bdf5fc; height:100%;float:left;padding: 10px;">
    <b>Menu</b><br>
    <a href="main.py">Main page</a><br>
    <br>
    <a href="cgiInput.py">Calculating GC Content</a><br>
    <br>
    <a href="GOR.py">Protein Secondary Structure Prediction</a><br>
    <br>
    <a href="cv.html">GOR validation report</a><br>
    <br>
    <a href="dna2protein.py">DNA2Protein</a><br>    
    <br>
    <a href="callAlignment.py">Alignment</a><br>
    <br>
    <a href="callValidation.py">Alignment Validation</a><br>
    <br>
    <a href="Correlations_Benchmarking_1.pdf">Alignment correlation and benchmarking</a><br>

  </div>
  <div id="introduction" style="background-color:#6affda; height:30%" <pre=""><br>
       Here you can run GOR5-prediction algorithms using multiple alignment files.<br> 
            

  </div> <div id="input info" style="background-color:#fc9a00">
  <h3>Input and Output: </h3>
  <p> Input: Multiple alignment files.<br>
  Output: A file with secondary structures predicted by a chosen GOR5 algorithm.<br>
  </p>  
  </div><br>
  
  {% if result %}
<div id="content">
  <h3>Result:</h3>
  <a href="{{ result }}">Predicted structures</a><br>
</div>
   

  {% else %}  
  <script>
// Function to toggle visibility based on selectors
function toggleVisibility() {
        
    // Handle model/standard toggle
    var selectionInputType2 = document.getElementById("inputType2").value;
    document.getElementById("fileUploadBox").style.display = selectionInputType2 == "model" ? "" : "none";
}

// Set up event listeners on page load
document.addEventListener('DOMContentLoaded', function() {
    // Initial visibility setup
    toggleVisibility();
    
    // Setup change listeners
    document.getElementById("inputType2").addEventListener("change", toggleVisibility);
});
</script>
  <form action="GOR5.py" method="post" enctype="multipart/form-data" title="PDB ID and Protein Sequence"><br><br>
    
    <label for="maf">Multiple alignment files:</label>
    <input type="file" name="maf" id="maf" multiple><br><br>
<select id="inputType2">
        <option value="model">Upload your own model</option>
        <option value="standard">Use our models</option>
    </select><br><br>

    <div id="fileUploadBox" style="display:none;">
        <input type="file" name="modelFile" id="modelFile">
    </div>

    <label for="method">Specify GOR Algorithm:</label>
    <select name="method" id="method">
    <option value="">Select a method...</option>
        <option value="GOR5_GOR1">GOR5_GOR1</option>
        <option value="GOR5_GOR3">GOR5_GOR3</option>
        <option value="GOR5_GOR4">GOR5_GOR4</option>
    </select><br><br>

    <h5>Optional parameters:</h3>

<label for="k">k := window size for GOR prediction - our models require k=8:</label>
<input type="number" id="k" name="k"><div>Default=8</div><br><br>

<label for="sc">Smoothing constant used in GOR prediction (float):</label>
<input type="number" id="sc" name="sc" step="any"><div><br><br>


<label for="ppt">Type of post-processing to apply:</label>
<select id="ppt" name="ppt">
    <option value="">Select a post-processing method...</option>
    <option value="1">Strictly remove helices or strands >= l</option>
    <option value="2">Remove Smooth alternating patterns</option>
    <option value="3">Both</option>
</select><br><br>

<label for="l">l := maximum length of short structures to remove:</label>
<input type="number" id="l" name="l"><div>Recommended default: 2</div><br><br>

    <input type="submit" value="Submit">
</form>



{% endif %}

</body></html>'''

form = cgi.FieldStorage()

UPLOAD_DIR = 'uploads'
MODEL1 = 'model1_big.txt'
MODEL3 = 'model3_big.txt'
MODEL4 = 'model4_big.txt'

# Getting form values

input_type = form.getvalue('inputType2', '')
selected_method = form.getvalue('method', '')
scaledValues = 'sv'
k = form.getvalue('k', '8')
sc = form.getvalue('sc', '0.35')
sc = sc.replace(',', '.')
ppt = form.getvalue('ppt', '1')
l = form.getvalue('l', '2')


x = None

if selected_method:
  if "maf" in form:
        files = form['maf']
        UPLOAD_DIR = Path('uploads/maf')   
        UPLOAD_DIR.mkdir(parents=True, exist_ok=True)
        if not isinstance(files, list):
                files = [files]
        for item in files:
            if item.filename:
                filepath = UPLOAD_DIR / Path(item.filename).name
                with open(filepath, 'wb') as f:
                    f.write(item.file.read())
        model_file = MODEL1 if selected_method == "GOR5_GOR1" else MODEL3 if selected_method == "GOR5_GOR3" else MODEL4  
        if input_type == 'model' and 'modelFile' in form:
            premodel = form['modelFile']
            fileContent = premodel.file.read()
            model = os.path.join(UPLOAD_DIR, os.path.basename(premodel.filename))
            with open(model, "wb") as mFile:
                mFile.write(fileContent)
            model_file = model
        command = ['java', '-jar', 'predict.jar', '--model', model_file, '--format', 'txt', '--maf', UPLOAD_DIR]
        if scaledValues:
            command.extend(['-sv'])
        if k:
            command.extend(['-k', k])
        if sc:            
            command.extend(['-sc', sc])
        if ppt:
            command.extend(['-ppt', ppt])
        if l:
            command.extend(['-l', l])
        

        pre_outname = "predicted_ss.txt"
        UPLOAD_DIR2 = Path('uploads') 
        outFilePath2 = os.path.join(UPLOAD_DIR2, pre_outname)
        with open(outFilePath2, 'w') as f:
            subprocess.run(command, stdout=f, stderr=subprocess.PIPE)
        x = outFilePath2
        #subprocess.run(['java', '-jar', 'validate1.jar', '-p', 'uploads/pred_out.txt', '-r', outFilePath1, '-s', 'summary.txt', '-d', 'detailed_statistics.txt', '-f', 'txt'], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        subprocess.run(['rm', '-rvf', UPLOAD_DIR], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        
            
  
      



        




headers = {'User-Agent': 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:23.0) Gecko/20100101 Firefox/23.0'}
print(jinja2.Environment().from_string(HTML).render(result=x))






